package org.mortbay.jetty.j2se6;

import java.io.IOException;
import java.net.InetSocketAddress;

import org.mortbay.jetty.Server;

import com.sun.net.httpserver.HttpServer;
import com.sun.net.httpserver.HttpsServer;
import com.sun.net.httpserver.spi.HttpServerProvider;

/**
 * Jetty implementation of <a href="http://java.sun.com/javase/6/docs/jre/api/net/httpserver/spec/index.html">Java HTTP Server SPI</a>
 * @author lorban
 */
public class JettyHttpServerProvider extends HttpServerProvider
{

    private static Server _server;

    public static void setServer(Server server)
    {
    	_server = server;
    }

    @Override
    public HttpServer createHttpServer(InetSocketAddress addr, int backlog)
            throws IOException
    {
        Server server = _server;
    	boolean noServerCleanUp = true;
        if (server == null)
        {
        	server = new Server();
        	noServerCleanUp = false;
        }

        JettyHttpServer jettyHttpServer = new JettyHttpServer(server, noServerCleanUp);
        jettyHttpServer.bind(addr, backlog);
        return jettyHttpServer;
    }

    @Override
    public HttpsServer createHttpsServer(InetSocketAddress addr, int backlog)
            throws IOException
    {
        throw new UnsupportedOperationException();
    }

}
